/* gtk_style.c generated by valac, the Vala compiler
 * generated from gtk_style.vala, do not modify */

/* gtk_style.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define TYPE_SYSTEM_STYLE (system_style_get_type ())
#define SYSTEM_STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_STYLE, SystemStyle))
#define SYSTEM_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_STYLE, SystemStyleClass))
#define IS_SYSTEM_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_STYLE))
#define IS_SYSTEM_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_STYLE))
#define SYSTEM_STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_STYLE, SystemStyleClass))

typedef struct _SystemStyle SystemStyle;
typedef struct _SystemStyleClass SystemStyleClass;
typedef struct _SystemStylePrivate SystemStylePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SystemStyle {
	GObject parent_instance;
	SystemStylePrivate * priv;
};

struct _SystemStyleClass {
	GObjectClass parent_class;
};

struct _SystemStylePrivate {
	char* _bg_color;
	char* _fg_color;
	char* _sl_color;
	char* _lg_color;
	char* _lt_color;
	char* _dr_color;
	char* _lk_color;
};


static gpointer system_style_parent_class = NULL;

GType system_style_get_type (void);
#define SYSTEM_STYLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SYSTEM_STYLE, SystemStylePrivate))
enum  {
	SYSTEM_STYLE_DUMMY_PROPERTY,
	SYSTEM_STYLE_BG_COLOR,
	SYSTEM_STYLE_FG_COLOR,
	SYSTEM_STYLE_SL_COLOR,
	SYSTEM_STYLE_LG_COLOR,
	SYSTEM_STYLE_LT_COLOR,
	SYSTEM_STYLE_DR_COLOR,
	SYSTEM_STYLE_LK_COLOR
};
void system_style_updateStyle (SystemStyle* self, GtkStyle* style);
SystemStyle* system_style_new (GtkStyle* style);
SystemStyle* system_style_construct (GType object_type, GtkStyle* style);
char* color_utils_rgb_to_hex (GdkColor* color);
void system_style_set_bg_color (SystemStyle* self, const char* value);
void system_style_set_lg_color (SystemStyle* self, const char* value);
void system_style_set_fg_color (SystemStyle* self, const char* value);
void system_style_set_sl_color (SystemStyle* self, const char* value);
void system_style_set_lk_color (SystemStyle* self, const char* value);
guint16 color_utils_lighter (guint16 color, guint16 delta);
void system_style_set_lt_color (SystemStyle* self, const char* value);
guint16 color_utils_darker (guint16 color, guint16 delta);
void system_style_set_dr_color (SystemStyle* self, const char* value);
void debug (const char* s, ...);
const char* system_style_get_bg_color (SystemStyle* self);
const char* system_style_get_fg_color (SystemStyle* self);
const char* system_style_get_sl_color (SystemStyle* self);
const char* system_style_get_lg_color (SystemStyle* self);
const char* system_style_get_lt_color (SystemStyle* self);
const char* system_style_get_dr_color (SystemStyle* self);
const char* system_style_get_lk_color (SystemStyle* self);
static void system_style_finalize (GObject* obj);
static void system_style_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void system_style_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



SystemStyle* system_style_construct (GType object_type, GtkStyle* style) {
	SystemStyle * self;
	g_return_val_if_fail (style != NULL, NULL);
	self = (SystemStyle*) g_object_new (object_type, NULL);
	system_style_updateStyle (self, style);
	return self;
}


SystemStyle* system_style_new (GtkStyle* style) {
	return system_style_construct (TYPE_SYSTEM_STYLE, style);
}


void system_style_updateStyle (SystemStyle* self, GtkStyle* style) {
	char* _tmp1_;
	GdkColor _tmp0_;
	char* _tmp3_;
	GdkColor _tmp2_;
	char* _tmp5_;
	GdkColor _tmp4_;
	char* _tmp7_;
	GdkColor _tmp6_;
	GValue _tmp8_ = {0};
	GValue v;
	char* _tmp11_;
	GdkColor _tmp10_;
	GdkColor _tmp9_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (style != NULL);
	system_style_set_bg_color (self, _tmp1_ = color_utils_rgb_to_hex ((_tmp0_ = style->bg[GTK_STATE_NORMAL], &_tmp0_)));
	_g_free0 (_tmp1_);
	system_style_set_lg_color (self, _tmp3_ = color_utils_rgb_to_hex ((_tmp2_ = style->light[GTK_STATE_NORMAL], &_tmp2_)));
	_g_free0 (_tmp3_);
	system_style_set_fg_color (self, _tmp5_ = color_utils_rgb_to_hex ((_tmp4_ = style->fg[GTK_STATE_NORMAL], &_tmp4_)));
	_g_free0 (_tmp5_);
	system_style_set_sl_color (self, _tmp7_ = color_utils_rgb_to_hex ((_tmp6_ = style->bg[GTK_STATE_SELECTED], &_tmp6_)));
	_g_free0 (_tmp7_);
	v = (g_value_init (&_tmp8_, GDK_TYPE_COLOR), _tmp8_);
	gtk_style_get_style_property (style, GTK_TYPE_WIDGET, "link-color", &v);
	system_style_set_lk_color (self, _tmp11_ = color_utils_rgb_to_hex ((_tmp10_ = (G_VALUE_HOLDS (&v, GDK_TYPE_COLOR) && g_value_get_boxed (&v)) ? (*((GdkColor*) g_value_get_boxed (&v))) : (g_warning ("Invalid GValue unboxing (wrong type or NULL)"), _tmp9_), &_tmp10_)));
	_g_free0 (_tmp11_);
	{
		GdkColor _tmp12_ = {0};
		GdkColor light_color;
		char* _tmp13_;
		light_color = (memset (&_tmp12_, 0, sizeof (GdkColor)), _tmp12_);
		light_color.red = color_utils_lighter (style->fg[GTK_STATE_NORMAL].red, (guint16) (100 * 256));
		light_color.green = color_utils_lighter (style->fg[GTK_STATE_NORMAL].green, (guint16) (100 * 256));
		light_color.blue = color_utils_lighter (style->fg[GTK_STATE_NORMAL].blue, (guint16) (100 * 256));
		system_style_set_lt_color (self, _tmp13_ = color_utils_rgb_to_hex (&light_color));
		_g_free0 (_tmp13_);
	}
	{
		GdkColor _tmp14_ = {0};
		GdkColor dark_color;
		char* _tmp15_;
		dark_color = (memset (&_tmp14_, 0, sizeof (GdkColor)), _tmp14_);
		dark_color.red = color_utils_darker (style->bg[GTK_STATE_NORMAL].red, (guint16) (20 * 256));
		dark_color.green = color_utils_darker (style->bg[GTK_STATE_NORMAL].green, (guint16) (20 * 256));
		dark_color.blue = color_utils_darker (style->bg[GTK_STATE_NORMAL].blue, (guint16) (20 * 256));
		system_style_set_dr_color (self, _tmp15_ = color_utils_rgb_to_hex (&dark_color));
		_g_free0 (_tmp15_);
	}
	debug ("New style", NULL);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
}


const char* system_style_get_bg_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_bg_color;
	return result;
}


void system_style_set_bg_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_bg_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_bg_color), _tmp0_);
	g_object_notify ((GObject *) self, "bg-color");
}


const char* system_style_get_fg_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_fg_color;
	return result;
}


void system_style_set_fg_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_fg_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_fg_color), _tmp0_);
	g_object_notify ((GObject *) self, "fg-color");
}


const char* system_style_get_sl_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_sl_color;
	return result;
}


void system_style_set_sl_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_sl_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_sl_color), _tmp0_);
	g_object_notify ((GObject *) self, "sl-color");
}


const char* system_style_get_lg_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_lg_color;
	return result;
}


void system_style_set_lg_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_lg_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_lg_color), _tmp0_);
	g_object_notify ((GObject *) self, "lg-color");
}


const char* system_style_get_lt_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_lt_color;
	return result;
}


void system_style_set_lt_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_lt_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_lt_color), _tmp0_);
	g_object_notify ((GObject *) self, "lt-color");
}


const char* system_style_get_dr_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_dr_color;
	return result;
}


void system_style_set_dr_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_dr_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_dr_color), _tmp0_);
	g_object_notify ((GObject *) self, "dr-color");
}


const char* system_style_get_lk_color (SystemStyle* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_lk_color;
	return result;
}


void system_style_set_lk_color (SystemStyle* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_lk_color = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_lk_color), _tmp0_);
	g_object_notify ((GObject *) self, "lk-color");
}


static void system_style_class_init (SystemStyleClass * klass) {
	system_style_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SystemStylePrivate));
	G_OBJECT_CLASS (klass)->get_property = system_style_get_property;
	G_OBJECT_CLASS (klass)->set_property = system_style_set_property;
	G_OBJECT_CLASS (klass)->finalize = system_style_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_BG_COLOR, g_param_spec_string ("bg-color", "bg-color", "bg-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_FG_COLOR, g_param_spec_string ("fg-color", "fg-color", "fg-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_SL_COLOR, g_param_spec_string ("sl-color", "sl-color", "sl-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_LG_COLOR, g_param_spec_string ("lg-color", "lg-color", "lg-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_LT_COLOR, g_param_spec_string ("lt-color", "lt-color", "lt-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_DR_COLOR, g_param_spec_string ("dr-color", "dr-color", "dr-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_STYLE_LK_COLOR, g_param_spec_string ("lk-color", "lk-color", "lk-color", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void system_style_instance_init (SystemStyle * self) {
	self->priv = SYSTEM_STYLE_GET_PRIVATE (self);
}


static void system_style_finalize (GObject* obj) {
	SystemStyle * self;
	self = SYSTEM_STYLE (obj);
	_g_free0 (self->priv->_bg_color);
	_g_free0 (self->priv->_fg_color);
	_g_free0 (self->priv->_sl_color);
	_g_free0 (self->priv->_lg_color);
	_g_free0 (self->priv->_lt_color);
	_g_free0 (self->priv->_dr_color);
	_g_free0 (self->priv->_lk_color);
	G_OBJECT_CLASS (system_style_parent_class)->finalize (obj);
}


GType system_style_get_type (void) {
	static GType system_style_type_id = 0;
	if (system_style_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (SystemStyleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) system_style_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SystemStyle), 0, (GInstanceInitFunc) system_style_instance_init, NULL };
		system_style_type_id = g_type_register_static (G_TYPE_OBJECT, "SystemStyle", &g_define_type_info, 0);
	}
	return system_style_type_id;
}


static void system_style_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SystemStyle * self;
	self = SYSTEM_STYLE (object);
	switch (property_id) {
		case SYSTEM_STYLE_BG_COLOR:
		g_value_set_string (value, system_style_get_bg_color (self));
		break;
		case SYSTEM_STYLE_FG_COLOR:
		g_value_set_string (value, system_style_get_fg_color (self));
		break;
		case SYSTEM_STYLE_SL_COLOR:
		g_value_set_string (value, system_style_get_sl_color (self));
		break;
		case SYSTEM_STYLE_LG_COLOR:
		g_value_set_string (value, system_style_get_lg_color (self));
		break;
		case SYSTEM_STYLE_LT_COLOR:
		g_value_set_string (value, system_style_get_lt_color (self));
		break;
		case SYSTEM_STYLE_DR_COLOR:
		g_value_set_string (value, system_style_get_dr_color (self));
		break;
		case SYSTEM_STYLE_LK_COLOR:
		g_value_set_string (value, system_style_get_lk_color (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void system_style_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SystemStyle * self;
	self = SYSTEM_STYLE (object);
	switch (property_id) {
		case SYSTEM_STYLE_BG_COLOR:
		system_style_set_bg_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_FG_COLOR:
		system_style_set_fg_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_SL_COLOR:
		system_style_set_sl_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_LG_COLOR:
		system_style_set_lg_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_LT_COLOR:
		system_style_set_lt_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_DR_COLOR:
		system_style_set_dr_color (self, g_value_get_string (value));
		break;
		case SYSTEM_STYLE_LK_COLOR:
		system_style_set_lk_color (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




