/* status_bar_smart.c generated by valac, the Vala compiler
 * generated from status_bar_smart.vala, do not modify */

/* status_bar_smart.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <time.h>
#include <glib/gi18n-lib.h>
#include <config.h>


#define TYPE_STATUSBAR_SMART (statusbar_smart_get_type ())
#define STATUSBAR_SMART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUSBAR_SMART, StatusbarSmart))
#define STATUSBAR_SMART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUSBAR_SMART, StatusbarSmartClass))
#define IS_STATUSBAR_SMART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUSBAR_SMART))
#define IS_STATUSBAR_SMART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUSBAR_SMART))
#define STATUSBAR_SMART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUSBAR_SMART, StatusbarSmartClass))

typedef struct _StatusbarSmart StatusbarSmart;
typedef struct _StatusbarSmartClass StatusbarSmartClass;
typedef struct _StatusbarSmartPrivate StatusbarSmartPrivate;

#define STATUSBAR_SMART_TYPE_STATUS_TYPE (statusbar_smart_status_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_LOG_WINDOW (log_window_get_type ())
#define LOG_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOG_WINDOW, LogWindow))
#define LOG_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOG_WINDOW, LogWindowClass))
#define IS_LOG_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOG_WINDOW))
#define IS_LOG_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOG_WINDOW))
#define LOG_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOG_WINDOW, LogWindowClass))

typedef struct _LogWindow LogWindow;
typedef struct _LogWindowClass LogWindowClass;

struct _StatusbarSmart {
	GtkVBox parent_instance;
	StatusbarSmartPrivate * priv;
};

struct _StatusbarSmartClass {
	GtkVBoxClass parent_class;
};

struct _StatusbarSmartPrivate {
	GtkHSeparator* sep;
	GtkImage* img;
	GtkLabel* label;
	gboolean warning;
	char* log;
};

typedef enum  {
	STATUSBAR_SMART_STATUS_TYPE_UPDATING,
	STATUSBAR_SMART_STATUS_TYPE_SENDING_DATA,
	STATUSBAR_SMART_STATUS_TYPE_DATA_SENT,
	STATUSBAR_SMART_STATUS_TYPE_FINISH_OK,
	STATUSBAR_SMART_STATUS_TYPE_FINISH_ERROR
} StatusbarSmartStatusType;


static gpointer statusbar_smart_parent_class = NULL;

GType statusbar_smart_get_type (void);
#define STATUSBAR_SMART_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATUSBAR_SMART, StatusbarSmartPrivate))
enum  {
	STATUSBAR_SMART_DUMMY_PROPERTY
};
GType statusbar_smart_status_type_get_type (void);
static gboolean statusbar_smart_log_click (StatusbarSmart* self, GdkEventButton* event);
static gboolean _statusbar_smart_log_click_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
StatusbarSmart* statusbar_smart_new (void);
StatusbarSmart* statusbar_smart_construct (GType object_type);
LogWindow* log_window_new (const char* log);
LogWindow* log_window_construct (GType object_type, const char* log);
GType log_window_get_type (void);
static void statusbar_smart_push (StatusbarSmart* self, const char* icon, const char* text);
static void statusbar_smart_push_custom (StatusbarSmart* self, const char* icon_path, const char* text);
void statusbar_smart_logging (StatusbarSmart* self, const char* line);
void statusbar_smart_log_warning (StatusbarSmart* self, const char* line);
void time_utils_get_current_time (struct tm* result);
void statusbar_smart_set_status (StatusbarSmart* self, StatusbarSmartStatusType status_type, const char* message);
static void statusbar_smart_finalize (GObject* obj);




GType statusbar_smart_status_type_get_type (void) {
	static GType statusbar_smart_status_type_type_id = 0;
	if (G_UNLIKELY (statusbar_smart_status_type_type_id == 0)) {
		static const GEnumValue values[] = {{STATUSBAR_SMART_STATUS_TYPE_UPDATING, "STATUSBAR_SMART_STATUS_TYPE_UPDATING", "updating"}, {STATUSBAR_SMART_STATUS_TYPE_SENDING_DATA, "STATUSBAR_SMART_STATUS_TYPE_SENDING_DATA", "sending-data"}, {STATUSBAR_SMART_STATUS_TYPE_DATA_SENT, "STATUSBAR_SMART_STATUS_TYPE_DATA_SENT", "data-sent"}, {STATUSBAR_SMART_STATUS_TYPE_FINISH_OK, "STATUSBAR_SMART_STATUS_TYPE_FINISH_OK", "finish-ok"}, {STATUSBAR_SMART_STATUS_TYPE_FINISH_ERROR, "STATUSBAR_SMART_STATUS_TYPE_FINISH_ERROR", "finish-error"}, {0, NULL, NULL}};
		statusbar_smart_status_type_type_id = g_enum_register_static ("StatusbarSmartStatusType", values);
	}
	return statusbar_smart_status_type_type_id;
}


static gboolean _statusbar_smart_log_click_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	return statusbar_smart_log_click (self, event);
}


StatusbarSmart* statusbar_smart_construct (GType object_type) {
	StatusbarSmart * self;
	GtkHSeparator* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* _tmp2_;
	GtkEventBox* event_img;
	GtkHBox* hbox;
	self = g_object_newv (object_type, 0, NULL);
	self->priv->sep = (_tmp0_ = g_object_ref_sink ((GtkHSeparator*) gtk_hseparator_new ()), _g_object_unref0 (self->priv->sep), _tmp0_);
	self->priv->img = (_tmp1_ = g_object_ref_sink ((GtkImage*) gtk_image_new ()), _g_object_unref0 (self->priv->img), _tmp1_);
	self->priv->label = (_tmp2_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->label), _tmp2_);
	event_img = g_object_ref_sink ((GtkEventBox*) gtk_event_box_new ());
	gtk_container_add ((GtkContainer*) event_img, (GtkWidget*) self->priv->img);
	gtk_widget_set_events ((GtkWidget*) event_img, (gint) GDK_BUTTON_PRESS_MASK);
	g_signal_connect_object ((GtkWidget*) event_img, "button-press-event", (GCallback) _statusbar_smart_log_click_gtk_widget_button_press_event, self, 0);
	hbox = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 5));
	gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) event_img, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) self->priv->label, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) self->priv->sep, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) hbox, FALSE, FALSE, (guint) 0);
	_g_object_unref0 (event_img);
	_g_object_unref0 (hbox);
	return self;
}


StatusbarSmart* statusbar_smart_new (void) {
	return statusbar_smart_construct (TYPE_STATUSBAR_SMART);
}


static gboolean statusbar_smart_log_click (StatusbarSmart* self, GdkEventButton* event) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if ((*event).button == 1) {
		LogWindow* log_window;
		log_window = g_object_ref_sink (log_window_new (self->priv->log));
		gtk_widget_show_all ((GtkWidget*) log_window);
		_g_object_unref0 (log_window);
	}
	result = FALSE;
	return result;
}


static void statusbar_smart_push (StatusbarSmart* self, const char* icon, const char* text) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	g_return_if_fail (text != NULL);
	gtk_image_set_from_stock (self->priv->img, icon, GTK_ICON_SIZE_MENU);
	gtk_label_set_label (self->priv->label, text);
}


static void statusbar_smart_push_custom (StatusbarSmart* self, const char* icon_path, const char* text) {
	GError * _inner_error_;
	GdkPixbufAnimation* anima;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon_path != NULL);
	g_return_if_fail (text != NULL);
	_inner_error_ = NULL;
	anima = gdk_pixbuf_animation_new_from_file (icon_path, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_image_set_from_animation (self->priv->img, anima);
	gtk_label_set_label (self->priv->label, text);
	_g_object_unref0 (anima);
}


void statusbar_smart_log_warning (StatusbarSmart* self, const char* line) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	self->priv->warning = TRUE;
	statusbar_smart_logging (self, line);
}


static char* g_time_format (struct tm *self, const char* format) {
	char* result;
	gchar* _tmp0_;
	gint buffer_size;
	gint buffer_length1;
	gchar* buffer;
	g_return_val_if_fail (format != NULL, NULL);
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, buffer_size = buffer_length1, _tmp0_);
	strftime (buffer, buffer_length1, format, &(*self));
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
	return result;
}


void statusbar_smart_logging (StatusbarSmart* self, const char* line) {
	char* _tmp4_;
	char* _tmp3_;
	char* _tmp2_;
	struct tm _tmp1_;
	struct tm _tmp0_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	self->priv->log = (_tmp4_ = g_strconcat (self->priv->log, _tmp3_ = g_strdup_printf ("[%s] %s\n", _tmp2_ = g_time_format ((_tmp1_ = (time_utils_get_current_time (&_tmp0_), _tmp0_), &_tmp1_), "%b %d %k:%M:%S"), line), NULL), _g_free0 (self->priv->log), _tmp4_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp2_);
}


void statusbar_smart_set_status (StatusbarSmart* self, StatusbarSmartStatusType status_type, const char* message) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	switch (status_type) {
		case STATUSBAR_SMART_STATUS_TYPE_FINISH_OK:
		{
			if (self->priv->warning) {
				statusbar_smart_push (self, "gtk-dialog-warning", _ ("updated "));
				self->priv->warning = FALSE;
			} else {
				statusbar_smart_push (self, "gtk-apply", _ ("updated "));
			}
			break;
		}
		case STATUSBAR_SMART_STATUS_TYPE_UPDATING:
		{
			statusbar_smart_push_custom (self, PROGRESS_PATH, _ ("updating... "));
			break;
		}
		case STATUSBAR_SMART_STATUS_TYPE_SENDING_DATA:
		{
			statusbar_smart_push_custom (self, PROGRESS_PATH, message);
			break;
		}
		case STATUSBAR_SMART_STATUS_TYPE_DATA_SENT:
		{
			statusbar_smart_push (self, "gtk-info", message);
			break;
		}
		case STATUSBAR_SMART_STATUS_TYPE_FINISH_ERROR:
		{
			statusbar_smart_push (self, "gtk-dialog-warning", message);
			statusbar_smart_log_warning (self, message);
			break;
		}
	}
}


static void statusbar_smart_class_init (StatusbarSmartClass * klass) {
	statusbar_smart_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatusbarSmartPrivate));
	G_OBJECT_CLASS (klass)->finalize = statusbar_smart_finalize;
}


static void statusbar_smart_instance_init (StatusbarSmart * self) {
	self->priv = STATUSBAR_SMART_GET_PRIVATE (self);
	self->priv->warning = FALSE;
	self->priv->log = g_strdup ("");
}


static void statusbar_smart_finalize (GObject* obj) {
	StatusbarSmart * self;
	self = STATUSBAR_SMART (obj);
	_g_object_unref0 (self->priv->sep);
	_g_object_unref0 (self->priv->img);
	_g_object_unref0 (self->priv->label);
	_g_free0 (self->priv->log);
	G_OBJECT_CLASS (statusbar_smart_parent_class)->finalize (obj);
}


GType statusbar_smart_get_type (void) {
	static GType statusbar_smart_type_id = 0;
	if (statusbar_smart_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusbarSmartClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) statusbar_smart_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusbarSmart), 0, (GInstanceInitFunc) statusbar_smart_instance_init, NULL };
		statusbar_smart_type_id = g_type_register_static (GTK_TYPE_VBOX, "StatusbarSmart", &g_define_type_info, 0);
	}
	return statusbar_smart_type_id;
}




